#ifndef CREATURE_H
#define CREATURE_H



// Included Header Files

#include "Entity.h"
#include "Inventory.h"



// Global Variables

#define RIGHT_HAND	0
#define LEFT_HAND	1

struct Skill {
	const char *name;
	short level;
	const char *description;
};



/*	**********************************************************
	* Creature                                               *
	* --------                                               *
	* An entity that represents a player, NPC, mob, etc.     *
	**********************************************************	*/

class Creature : public Entity
{
private:
	// General Attributes
	const char *surname;
	short race;
	short profession;
	short primaryHand;
	short secondaryHand;

	// Statistics
	short strength;
	short dexterity;
	short agility;
	short constitution;

	// Defensive Skills
	Skill unarmoredResistance;
	Skill armorUsage;
	Skill evasion;
	Skill block;
	Skill shield;
	Skill parry;
	Skill riposte;
	Skill multipleOpponent;

	// Offensive Skills
	Skill unarmed;
	Skill smallPiercing;
	Skill dualWield;
	Skill multipleAttack;  // should we add this???
	Skill shieldBash;
	Skill punch;
	Skill kick;

	// Equipment
	Inventory inventory;
public:
	// Constructors & Destructors
	Creature();
	virtual ~Creature();

	void setCreatureStats(short skillLevel);

	// Accessors & Modifiers
	Item GetPrimaryWeapon() { return inventory.GetPrimaryHand(); }
	Item GetSecondaryWeapon() { return inventory.GetSecondaryHand(); }
	//short getPrimaryHand()		{ return primaryHand; }
	//short getStrength()			{ return strength; }
	//short getDexterity()		{ return dexterity; }
	//short getAgility()			{ return agility; }
	//short getConstitution()		{ return constitution; }
	//short getSmallPiercing()	{ return smallPiercing; }
	//short getUnarmed()			{ return unarmed; }

	short GetWeaponSkill(short whichHand);

	// TODO: Name
	void Attack(Creature *other);
	float AttackAccuracy(Creature *other, short whichHand);
	int DamageAvoidanceEvasion(Creature *other, float toHitChance);

	// TODO: Name
	void LearnSkill(Skill *skill);
};



#endif CREATURE_H